module.exports = function (dftool, roles) {

    /**
     * bound random
     */
    this.gauss = function (min, max, mean, dev) {
        function marsagliaPolar() {
            var s, u, v, norm;
            do {
                u = Math.random() * 2 - 1;
                v = Math.random() * 2 - 1;
                s = u * u + v * v;
            } while (s >= 1);
            norm = u * Math.sqrt(-2 * Math.log(s) / s);
            return dev * norm + mean;
        }
        var tst = marsagliaPolar();
        if (tst >= min && tst <= max) {
            return tst;
        }
        return gauss(min, max, mean, dev);
    };

    /**
     * pad unspecified roles with silent events
     */
    this.pad = function (e, doPad) {
        var o = [];
        for (var nm in roles) {
            var roleparts = false;
            for (var rn in e.roles) {
                var rnm = e.roles[rn];
                if (rnm === nm) {
                    roleparts = true;
                }
            }
            if (roleparts) {
                o.push({role: nm, event: e.event, duration: e.duration});
            } else if ((!doPad) || (doPad && nm!=="Drums" && nm!=="Bass")) {
                o.push({role: nm, event: "silent", duration: e.duration});
            }
        }
        return o;
    };

    /**
     * weighted random
     */
    this.weighted = function (vals, weights) {
        var weighted = [];
        for (var curr = 0; curr < vals.length; curr++) {
            for (var i = 0; i < weights[curr]; i++) {
                weighted.push(vals[curr]);
            }
        }
        return weighted[Math.round(dftool.rand(0, weighted.length - 1))];
    };
    return this;
};
